import java.awt.*;
import java.awt.event.*;

public class Main extends Frame implements WindowListener
{
public static final int SIZE = 64;
Tree[] trees = new Tree[SIZE];

public Main(String name)
	{
	super(name);
	this.addWindowListener(this);
	Tree t;
	int i;
	Panel[] picpanels = new Panel[SIZE];

	Panel buttons = new Panel();
	Panel pics = new Panel();

	for(i=0;i<SIZE;i++)
		{
		picpanels[i] = new Panel();
		picpanels[i].setLayout(new BorderLayout());
		if (i==0)
			picpanels[i].add("Center",trees[i]=new GenePicker(Color.white));
		else
			{
			picpanels[i].add("Center",trees[i]=new GenePicker());
			pics.add(picpanels[i]);
			}
		}

	add("Center",pics);
	pics.setLayout(new FlowLayout());
	add("South",buttons);
	buttons.setLayout(new FlowLayout());

	MyButton b;

	for(i=0;i<SIZE;i++)
		{
		picpanels[i].add("South",b = new MyButton("Breed Me",i));
		b.addActionListener(new ActionListener()
				{
				public void actionPerformed(ActionEvent e)
				{breedFrom( ((MyButton)(e.getSource())) .id);}
				}
			);

		}

	Button q = new Button("Quit");

	buttons.add(q);
	q.addActionListener(new ActionListener()
				{
				public void actionPerformed(ActionEvent e)
				{ ((Frame)(e.getSource())).setVisible(false);}
				}
			);
	}

public static void main()
	{
	Frame f = new Main("Biomorphs");
	Tree t = new Tree();
	f.setSize((int)(Math.sqrt(SIZE)+1)*t.getPreferredSize().width,(int)(Math.sqrt(SIZE)+2)*t.getPreferredSize().height);
	f.setVisible(true);
	}

public void breedFrom(int id)
	{
trees[0].depth = trees[id].depth;
trees[0].length = trees[id].length;
trees[0].angle = trees[id].angle;
	multiply();
	}

public void multiply()
	{
	int i;
	for (i=0;i<SIZE;i++)
		{	
		trees[i].depth = trees[0].depth;
		trees[i].length = trees[0].length;
		trees[i].angle = trees[0].angle;
		trees[i].repaint();
		trees[i].mutate();
		}
	}

public void quit(ActionEvent e)
{
System.exit(0);
}

public void windowClosing(WindowEvent e)
	{
	System.exit(0);
	}

public void windowActivated(WindowEvent e) {;}
public void windowDeactivated(WindowEvent e) {;}
public void windowClosed(WindowEvent e) {;}
public void windowDeiconified(WindowEvent e) {;}
public void windowIconified(WindowEvent e) {;}
public void windowOpened(WindowEvent e) {;}

} // end Main Class
